#pragma once
#include "def.h"

#define VX(v)     ((v).mod*cos((v).angle))
#define VY(v)     ((v).mod*sin((v).angle))
#define VMOD(v)   ((v).mod)
#define VANGLE(v) ((v).angle)

#define MOD(x,y)  (sqrt(x*x + y*y))
#define ANGLE(x,y)((x==0.) ? 0. : ((x<0.)?atan(y/x)+M_PI:atan(y/x)))

// Base of 2D vectors.
typedef struct {
  double mod, angle; // Basic 2D vector components.
} Vec2;

// Vector manupulation.
void vect_cinit(Vec2* v, double x, double y);
void vect_pinit(Vec2* v, double mod, double angle);

// Describe any solid in 2D space.
struct Solid {
  double mass, dir, dir_vel; // Properties.
  Vec2 vel, pos, force; // Position/velocity vectors.
  void(*update)(struct Solid*, const double); // Update method.
};

typedef struct Solid Solid;

// Solid manipulation.
void solid_init(Solid* dest, const double mass, const Vec2* vel, const Vec2* pos);
Solid* solid_create(const double mass, const Vec2* vel, const Vec2* pos);
void solid_free(Solid* src);

